% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation, version 2.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Builds the jacobian for the minimisation  %
%  of the projection error in the image.      %
%                                             %
%   Created : 2005                            %
%    Author : Christopher Mei                 %
%                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

makeSparse=0;

if makeSparse
  JJ3 = sparse([],[],[],10 + 7*n_ima, 10 + 7*n_ima,126*n_ima + 100);
else
  JJ3 = zeros(10+7*n_ima, 10+7*n_ima);
end

ex3 = zeros(10 + 7*n_ima,1);
sfx=[];

for kk = 1:length(ind_active),     
  index = ind_active(kk);
  
  eval(['X_kk = X_' num2str(index) ';']);
  eval(['x_kk = x_' num2str(index) ';']);
    
  % '-' because it's a mirror...
  [xp,Jx] = omniCamProjection(-X_kk,...
			      [param(10+7*(kk-1)+1 : 10+7*(kk-1)+7);param(1:10)],...
			      mirror_p, mirror_d, mirror_type);
  %x(:,1:6)
  %Jx(1:3,1:6)
  %return
  exkk = xp-x_kk;
  [nlines,ncols]=size(exkk);
  exkk = reshape(exkk,ncols*nlines,1);
  
  sfx=[sfx;exkk];    
  
  A=Jx(:,8:17); %intrinsic
  B=Jx(:,1:7); %extrinsic
  
  if makeSparse
    JJ3(1:10,1:10) = JJ3(1:10,1:10) + sparse(A'*A);
    JJ3(10+7*(kk-1) + 1: 10+7*(kk-1) + 7,...
	10+7*(kk-1) + 1: 10+7*(kk-1) + 7) = sparse(B'*B);
    
    AB=sparse(A'*B);
  else
    JJ3(1:10,1:10) = JJ3(1:10,1:10) + A'*A;
    JJ3(10+7*(kk-1) + 1: 10+7*(kk-1) + 7,...
	10+7*(kk-1) + 1: 10+7*(kk-1) + 7) = B'*B;
    
    AB=A'*B;
  end
  JJ3(1:10, 10+7*(kk-1) + 1:10+7*(kk-1) + 7) = AB;
  JJ3(10+7*(kk-1) + 1:10+7*(kk-1) + 7, 1:10) = AB';
  
  ex3(1:10) = ex3(1:10) + A'*exkk;
  ex3(10+7*(kk-1) + 1:10+7*(kk-1) + 7) = B'*exkk;
end
