% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation, version 2.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Recomputes the reprojection error         %
%      (based on version by JYB)              %
%                                             %
%   Created : 2005                            %
%    Author : Christopher Mei                 %
%                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

check_active_images;

% Reproject the patterns on the images, and compute the pixel errors:

ex = []; % Global error vector

if ~exist('alpha_c'),
   alpha_c = 0;
end;

if ~exist('fc')
  if exist('KK_estimate')
    XI=[zeros(5,1);0;KK_estimate(1,1);KK_estimate(2,2); ...
	KK_estimate(1,3);KK_estimate(2,3)];
  else
    disp(['You must either use "Estimate" or calibration before' ...
	  ' calculating the error']);
    return
  end
else
  XI=[kc;alpha_c;fc(1);fc(2);cc(1);cc(2)];
end

for kk = 1:length(ind_active)
  index = ind_active(kk);
  sindex = num2str(index);
  eval(['Qw = Qw_' sindex ';']);
  eval(['Tw = Tw_' sindex ';']);   
  
  %if active_images(kk) & (~isnan(Qw(1))),
    
    V=[Qw;Tw;XI];
    
    eval(['x=x_' sindex ';']);
    eval(['X=X_' sindex ';']);

    xp=omniCamProjection(-X, V, mirror_p, mirror_d, mirror_type);
    
    part_ex=xp-x;
    eval(['y_' sindex ' = xp;'])
    eval(['ex_' sindex ' = part_ex;']);
    
    ex=[ex part_ex];
  %end
end;

err_mean_abs=mean(abs(ex),2);
err_std_abs=std(abs(ex),0,2);
err_std = std(ex')';
