% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation, version 2.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     Recomputes the reprojection error       %
%  on the sphere for an unbiased calibration  %
%                                             %
%   Created : 2005                            %
%    Author : Christopher Mei                 %
%                                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

check_active_images;

% Reproject the patterns on the images, and compute the pixel errors:

ex_sphere_rad = []; % Global error vector in radians
ex_sphere_pix = []; % Global error vector in pixels

if ~exist('alpha_c'),
   alpha_c = 0;
end;

if ~exist('fc_sphere')
  disp(['You must calibration before' ...
	' calculating the error']);
  return
else
  XI=[kc_sphere;alpha_c_sphere;fc_sphere(1);fc_sphere(2);cc_sphere(1);cc_sphere(2)];
end

for kk = 1:length(ind_active)
  index = ind_active(kk);
  sindex = num2str(index);
  eval(['Qw = Qw_' sindex ';']);
  eval(['Tw = Tw_' sindex ';']);   
  
  if active_images(kk) & (~isnan(Qw(1))),
    
    V=[Qw;Tw;XI];
    
    eval(['x=x_' sindex ';']);
    eval(['X=X_' sindex ';']);
    
    xp=uProjection(-X, V, mirror_p, mirror_d, mirror_type);
    s=sphericalDistanceProjection(-X,x, V, mirror_p, mirror_d, mirror_type);
    
    part_ex_sphere_rad=s;
    part_ex_sphere_pix=xp-x;
    
    eval(['distSphereRad_' num2str(kk) ' = part_ex_sphere_rad;'])
    eval(['distSpherePix_' num2str(kk) ' = part_ex_sphere_pix;'])
    
    eval(['ex_sphere_pix_' num2str(kk) ' = part_ex_sphere_pix;']);
    
    ex_sphere_rad=[ex_sphere_rad part_ex_sphere_rad];
    ex_sphere_pix=[ex_sphere_pix part_ex_sphere_pix];
  end
end;

err_mean_abs_sphere_rad=mean(abs(ex_sphere_rad),2);
err_std_abs_sphere_rad=std(abs(ex_sphere_rad),0,2);

err_mean_abs_sphere_pix=mean(abs(ex_sphere_pix),2);
err_std_abs_sphere_pix=std(abs(ex_sphere_pix),0,2);
err_std_sphere_pix = std(ex_sphere_pix')';
