%%%%%%%%%%%%%%%%%%%% RECOMPUTES THE REPROJECTION ERROR %%%%%%%%%%%%%%%%%%%%%%%%
% This function must only be used after a 'normal' calibration (not
% unbiased). It calculates the error on the sphere.
%

if exist('biased_calib')&~biased_calib
  disp(['Call to this function is only valid after a ''normal''' ...
	' calibration (not unbiased)']);
end


%check_active_images;

% Reproject the patterns on the images, and compute the pixel errors:

ex_sphere = []; % Global error vector

if ~exist('alpha_c'),
   alpha_c = 0;
end;

if ~exist('fc')
  if exist('KK_estimate')
    XI=[zeros(5,1);0;KK_estimate(1,1);KK_estimate(2,2); ...
	KK_estimate(1,3);KK_estimate(2,3)];
  else
    disp(['You must either use "Estimate" or calibration before' ...
	  ' calculating the error']);
    return
  end
else
  XI=[kc;alpha_c;fc(1);fc(2);cc(1);cc(2)];
end

kval=[kc;alpha_c;fc;cc];

for kk = 1:length(ind_active)
  index = ind_active(kk);
  sindex = num2str(index);
  eval(['Qw = Qw_' sindex ';']);
  eval(['Tw = Tw_' sindex ';']);   
  
  if active_images(kk) & (~isnan(Qw(1))),
    
    V=[Qw;Tw;XI];
    
    eval(['x=x_' sindex ';']);
    eval(['X=X_' sindex ';']);

    xp=omniCamProjection(-X, V, mirror_p, mirror_d, mirror_type);
    
    part_ex=sphericalDistanceFromImage(xp,x,kval,mirror_p,mirror_d,mirror_type);
    eval(['y_sphere_' num2str(kk) ' = xp;'])
    eval(['ex_sphere_' num2str(kk) ' = part_ex;']);
    
    ex_sphere=[ex_sphere part_ex];
  end
end;

err_sphere_mean_abs=mean(abs(ex_sphere),2);
err_sphere_std_abs=std(abs(ex_sphere),0,2);
err_sphere_std = std(ex_sphere')';
