% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation, version 2.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
%

check_active_images;

if ~exist(['I_' num2str(ind_active(1))]),
    ima_read_calib;
    if isempty(ind_read),
        disp('Cannot extract corners without images');
        return;
    end;
end;

ima_show = input('Image(s) to show ([] = all active images) : ');

if isempty(ima_show)
  ima_show = ind_active;
end

if ~exist('fc')
  if exist('KK_estimate')
    XI=[zeros(5,1);0;KK_estimate(1,1);KK_estimate(2,2); ...
	KK_estimate(1,3);KK_estimate(2,3)];
  else
    disp(['You must either use "Estimate" or "Calibration" before' ...
	  ' displaying the results and calculating the error']);
    return
  end
else
  XI=[kc;alpha_c;fc(1);fc(2);cc(1);cc(2)];
end

for i=1:length(ima_show)
  index = ima_show(i);
  sindex = num2str(index);
  
  eval(['I=I_' sindex ';']);
  eval(['x=x_' sindex ';']);
  eval(['X=X_' sindex ';']);
  eval(['Qw=Qw_' sindex ';']);
  eval(['Tw=Tw_' sindex ';']);
    
  figure(i+1);
  if exist('imshow')&exist('uint8')
    imshow(uint8(I));
  else
    image(I);
    colormap(map);
  end
  hold on;
  
  plot(x(1,:),x(2,:),'r+');

  V=[Qw;Tw;XI];

  [XX,dXXdV] = omniCamProjection(-X, V, mirror_p, mirror_d, mirror_type);

  plot(XX(1,:),XX(2,:),'yx');
end

comp_omni_error;
err_std
