% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation, version 2.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
%

check_active_images;

if ~exist(['I_' num2str(ind_active(1))]),
    ima_read_calib;
    if isempty(ind_read),
        disp('Cannot extract corners without images');
        return;
    end;
end;

ima_show = input('Image(s) to show ([] = all active images) : ');

if isempty(ima_show)
  ima_show = ind_active;
end

if ~exist('fc_sphere')
  disp(['You must use "Calibration" before' ...
	  ' displaying the results and calculating the error']);
  return
else
  XI=[kc_sphere;alpha_c_sphere;fc_sphere;cc_sphere];
end

for i=1:length(ima_show)
  index = ima_show(i);
  sindex = num2str(index);
  
  eval(['I=I_' sindex ';']);
  eval(['x=x_' sindex ';']);
  eval(['X=X_' sindex ';']);
  eval(['Qw=Qw_' sindex ';']);
  eval(['Tw=Tw_' sindex ';']);
    
  figure(i+1);
  if exist('imshow')&exist('uint8')
    imshow(uint8(I));
  else
    image(I);
    colormap(map);
  end
  hold on;
  
  plot(x(1,:),x(2,:),'r+');

  V=[Qw;Tw;XI];
  
  XX = uProjection(-X, V, mirror_p, mirror_d, mirror_type);

  errorPix=mean(abs(XX-x),2)
  
  plot(XX(1,:),XX(2,:),'yx');

  error = sphericalDistanceProjection(-X,x, ...
				      [Qw;Tw;kc_sphere;alpha_c_sphere;fc_sphere;cc_sphere],...
				      mirror_p, mirror_d, ...
				      mirror_type);
  error = mean(error)
end

comp_omni_error_sphere;
err_mean_abs_sphere_rad
