% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation, version 2.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
%

omni=1;

%%%%%%%%%%%% Obtain mirror_type %%%%%%%%%%%%%
mirror_type = 0;

while ((mirror_type ~= 1)&(mirror_type ~= 2))
  mirror_type = input('Mirror type ([]=parabolic=1, hyperbolic=2) : ','s');

  if isempty(mirror_type)
    mirror_type=1;
    break;
  end

  mirror_type = str2num(mirror_type);
  if isempty(mirror_type)|~((mirror_type == 1)|(mirror_type == 2))
    disp('Please answer 1 or 2.');
  end
end

if(mirror_type==1)
  mirror_name = 'parabolic.';
else
  mirror_name = 'hyperbolic.';
end

disp(['Mirror type : ',mirror_name]);

%%%%%%%%%%%% Extra lens %%%%%%%%%%%%%
%lens = 1;

%lens = input('Does the system have an extra lens ? ([]=no, other=yes) : ','s');

%if isempty(lens)
%  lens=0;
%  disp('System without an extra lens.');
%else
%  lens=1;
%  disp('System with an extra lens.');
%end
%%%%%%%%%%%% Outer mirror %%%%%%%%%%%%%

%if lens
mirror_diam=[];

while (isempty(mirror_diam))
  mirror_diam = input(['Mirror diameter ? (in mm) : '],'s');
  
  mirror_diam = str2num(mirror_diam);
  
  if isempty(mirror_diam)
    disp('Please give at least an estimate of the mirror diameter.');
  else
     disp(['Mirror diameter : ', num2str(mirror_diam), 'mm.']);
     break;
  end
end

%%%%%%%%%%%%%% Obtain mirror values     %%%%%%%%%%%%%%

if mirror_type==1
  %Parabolic case
  disp('Paraboloid equation : sqrt(x^2+y^2+z^2)=z+2p');

  mirror_p = [];
  mirror_d = NaN;

  while isempty(mirror_p)
    mirror_p = input('Mirror parameter "p" (in mm) : ','s');
    
    mirror_p = str2num(mirror_p);

    if isempty(mirror_p)
      disp('Please give a value in mm.');
    end
  end

  disp(['Mirror parameter "p" : ',num2str(mirror_p),'mm']);
else
  %Hyperbolic case
  disp('Hyperboloid equation : (z+d/2)^2/a^2-x^2/b^2-y^2/b^2=1');

  mirror_a = [];
  mirror_b = [];

  while isempty(mirror_a)
    mirror_a = input('Mirror parameter "a" (in mm) : ','s');
    
    mirror_a = str2num(mirror_a);

    if isempty(mirror_a)
      disp('Please give a value in mm.');
    end
  end

  while isempty(mirror_b)
    mirror_b = input('Mirror parameter "b" (in mm) : ','s');
    
    mirror_b = str2num(mirror_b);

    if isempty(mirror_b)
      disp('Please give a value in mm.');
    end
  end

  disp(['Mirror parameters "[a,b]" : [',num2str(mirror_a),'mm,',num2str(mirror_b),'mm]']);
  [mirror_p,mirror_d]=ab2pd(mirror_a,mirror_b,mirror_type);
  disp(['Converted mirror parameters "[p,d]" : [',num2str(mirror_p),'mm,',num2str(mirror_d),'mm]']);

  mirror_depth = mirror_a*sqrt(1+(mirror_diam/(2*mirror_b))^2)+mirror_d/2;
  disp(['Depth of the mirror border : [',num2str(mirror_depth) 'mm]']);
end
