% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation, version 2.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
%

fprintf(1,['\n\nCalibration results after optimization using the' ...
	   ' metric on the sphere (with uncertainties):\n\n']);
fprintf(1,'Focal Length:          fc_sphere = [ %3.5f   %3.5f ] ± [ %3.5f   %3.5f ]\n',[fc_sphere;fc_error_sphere]);
fprintf(1,'Principal point:       cc_sphere = [ %3.5f   %3.5f ] ± [ %3.5f   %3.5f ]\n',[cc_sphere;cc_error_sphere]);
fprintf(1,'Skew:             alpha_c_sphere = [ %3.5f ] ± [ %3.5f  ]   => angle of pixel axes = %3.5f ± %3.5f degrees\n',[alpha_c_sphere;alpha_c_error_sphere],90 - atan(alpha_c_sphere)*180/pi,atan(alpha_c_error_sphere)*180/pi);
fprintf(1,'Distortion:            kc_sphere = [ %3.5f   %3.5f   %3.5f   %3.5f  %5.5f ] ± [ %3.5f   %3.5f   %3.5f   %3.5f  %5.5f ]\n',[kc_sphere;kc_error_sphere]);   
fprintf(1,['Pixel error+-std :          err = [ %3.5f   %3.5f ]+-[ %3.5f' ...
								   ' %3.5f ]\n'],err_mean_abs_sphere_pix,err_std_abs_sphere_pix);
fprintf(1,['Error in radian+-std :     err_sphere = [ %3.5f ]+-[' ...
						      ' %3.5f ]\n\n'],err_mean_abs_sphere_rad,err_std_abs_sphere_rad); 


fprintf(1,'Note: The numerical errors are approximately three times the standard deviations (for reference).\n\n')
