% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation, version 2.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software Foundation,
% Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                        %
% This function writes into a binary file the focals and %
% principal point coordinates of the KK projection       %
% matrix and the parameters of the mirror.               %
%                                                        %
%                                                        %
%   Created : 2005                                       %
%    Author : Christopher Mei                            %
%                                                        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function write_params_to_file(fileName,KK, mirror_p, mirror_d, ...
			      mirror_type, roi_min, roi_max)

fid = fopen(fileName,'w');

fwrite(fid,KK(1,1),'float');
fwrite(fid,KK(2,2),'float');
fwrite(fid,KK(1:2,3),'float');
fwrite(fid,mirror_p,'float');
fwrite(fid,mirror_d,'float');
fwrite(fid,mirror_type,'int');
fwrite(fid,roi_min(1),'float');
fwrite(fid,roi_min(2),'float');
fwrite(fid,roi_max(1),'float');
fwrite(fid,roi_max(2),'float');

fclose(fid);

